<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAARQuote ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAARQuote
 * @subpackage Arrays
 */
class ArrayOfAARQuote extends AbstractStructArrayBase
{
    /**
     * The AARQuote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AARQuote[]
     */
    public $AARQuote;
    /**
     * Constructor method for ArrayOfAARQuote
     * @uses ArrayOfAARQuote::setAARQuote()
     * @param \StructType\AARQuote[] $aARQuote
     */
    public function __construct(array $aARQuote = array())
    {
        $this
            ->setAARQuote($aARQuote);
    }
    /**
     * Get AARQuote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AARQuote[]|null
     */
    public function getAARQuote()
    {
        return isset($this->AARQuote) ? $this->AARQuote : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAARQuote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAARQuote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAARQuoteForArrayConstraintsFromSetAARQuote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAARQuoteAARQuoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfAARQuoteAARQuoteItem instanceof \StructType\AARQuote) {
                $invalidValues[] = is_object($arrayOfAARQuoteAARQuoteItem) ? get_class($arrayOfAARQuoteAARQuoteItem) : sprintf('%s(%s)', gettype($arrayOfAARQuoteAARQuoteItem), var_export($arrayOfAARQuoteAARQuoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AARQuote property can only contain items of type \StructType\AARQuote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AARQuote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AARQuote[] $aARQuote
     * @return \ArrayType\ArrayOfAARQuote
     */
    public function setAARQuote(array $aARQuote = array())
    {
        // validation for constraint: array
        if ('' !== ($aARQuoteArrayErrorMessage = self::validateAARQuoteForArrayConstraintsFromSetAARQuote($aARQuote))) {
            throw new \InvalidArgumentException($aARQuoteArrayErrorMessage, __LINE__);
        }
        if (is_null($aARQuote) || (is_array($aARQuote) && empty($aARQuote))) {
            unset($this->AARQuote);
        } else {
            $this->AARQuote = $aARQuote;
        }
        return $this;
    }
    /**
     * Add item to AARQuote value
     * @throws \InvalidArgumentException
     * @param \StructType\AARQuote $item
     * @return \ArrayType\ArrayOfAARQuote
     */
    public function addToAARQuote(\StructType\AARQuote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AARQuote) {
            throw new \InvalidArgumentException(sprintf('The AARQuote property can only contain items of type \StructType\AARQuote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AARQuote[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AARQuote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AARQuote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AARQuote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AARQuote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AARQuote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AARQuote
     */
    public function getAttributeName()
    {
        return 'AARQuote';
    }
}
