<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfApplicableTax ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfApplicableTax
 * @subpackage Arrays
 */
class ArrayOfApplicableTax extends AbstractStructArrayBase
{
    /**
     * The ApplicableTax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ApplicableTax[]
     */
    public $ApplicableTax;
    /**
     * Constructor method for ArrayOfApplicableTax
     * @uses ArrayOfApplicableTax::setApplicableTax()
     * @param \StructType\ApplicableTax[] $applicableTax
     */
    public function __construct(array $applicableTax = array())
    {
        $this
            ->setApplicableTax($applicableTax);
    }
    /**
     * Get ApplicableTax value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ApplicableTax[]|null
     */
    public function getApplicableTax()
    {
        return isset($this->ApplicableTax) ? $this->ApplicableTax : null;
    }
    /**
     * This method is responsible for validating the values passed to the setApplicableTax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setApplicableTax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateApplicableTaxForArrayConstraintsFromSetApplicableTax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfApplicableTaxApplicableTaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfApplicableTaxApplicableTaxItem instanceof \StructType\ApplicableTax) {
                $invalidValues[] = is_object($arrayOfApplicableTaxApplicableTaxItem) ? get_class($arrayOfApplicableTaxApplicableTaxItem) : sprintf('%s(%s)', gettype($arrayOfApplicableTaxApplicableTaxItem), var_export($arrayOfApplicableTaxApplicableTaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ApplicableTax property can only contain items of type \StructType\ApplicableTax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ApplicableTax value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ApplicableTax[] $applicableTax
     * @return \ArrayType\ArrayOfApplicableTax
     */
    public function setApplicableTax(array $applicableTax = array())
    {
        // validation for constraint: array
        if ('' !== ($applicableTaxArrayErrorMessage = self::validateApplicableTaxForArrayConstraintsFromSetApplicableTax($applicableTax))) {
            throw new \InvalidArgumentException($applicableTaxArrayErrorMessage, __LINE__);
        }
        if (is_null($applicableTax) || (is_array($applicableTax) && empty($applicableTax))) {
            unset($this->ApplicableTax);
        } else {
            $this->ApplicableTax = $applicableTax;
        }
        return $this;
    }
    /**
     * Add item to ApplicableTax value
     * @throws \InvalidArgumentException
     * @param \StructType\ApplicableTax $item
     * @return \ArrayType\ArrayOfApplicableTax
     */
    public function addToApplicableTax(\StructType\ApplicableTax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ApplicableTax) {
            throw new \InvalidArgumentException(sprintf('The ApplicableTax property can only contain items of type \StructType\ApplicableTax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ApplicableTax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ApplicableTax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ApplicableTax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ApplicableTax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ApplicableTax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ApplicableTax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ApplicableTax
     */
    public function getAttributeName()
    {
        return 'ApplicableTax';
    }
}
