<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfApplicableTaxDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfApplicableTaxDetail
 * @subpackage Arrays
 */
class ArrayOfApplicableTaxDetail extends AbstractStructArrayBase
{
    /**
     * The ApplicableTaxDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ApplicableTaxDetail[]
     */
    public $ApplicableTaxDetail;
    /**
     * Constructor method for ArrayOfApplicableTaxDetail
     * @uses ArrayOfApplicableTaxDetail::setApplicableTaxDetail()
     * @param \StructType\ApplicableTaxDetail[] $applicableTaxDetail
     */
    public function __construct(array $applicableTaxDetail = array())
    {
        $this
            ->setApplicableTaxDetail($applicableTaxDetail);
    }
    /**
     * Get ApplicableTaxDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ApplicableTaxDetail[]|null
     */
    public function getApplicableTaxDetail()
    {
        return isset($this->ApplicableTaxDetail) ? $this->ApplicableTaxDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setApplicableTaxDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setApplicableTaxDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateApplicableTaxDetailForArrayConstraintsFromSetApplicableTaxDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfApplicableTaxDetailApplicableTaxDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfApplicableTaxDetailApplicableTaxDetailItem instanceof \StructType\ApplicableTaxDetail) {
                $invalidValues[] = is_object($arrayOfApplicableTaxDetailApplicableTaxDetailItem) ? get_class($arrayOfApplicableTaxDetailApplicableTaxDetailItem) : sprintf('%s(%s)', gettype($arrayOfApplicableTaxDetailApplicableTaxDetailItem), var_export($arrayOfApplicableTaxDetailApplicableTaxDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ApplicableTaxDetail property can only contain items of type \StructType\ApplicableTaxDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ApplicableTaxDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ApplicableTaxDetail[] $applicableTaxDetail
     * @return \ArrayType\ArrayOfApplicableTaxDetail
     */
    public function setApplicableTaxDetail(array $applicableTaxDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($applicableTaxDetailArrayErrorMessage = self::validateApplicableTaxDetailForArrayConstraintsFromSetApplicableTaxDetail($applicableTaxDetail))) {
            throw new \InvalidArgumentException($applicableTaxDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($applicableTaxDetail) || (is_array($applicableTaxDetail) && empty($applicableTaxDetail))) {
            unset($this->ApplicableTaxDetail);
        } else {
            $this->ApplicableTaxDetail = $applicableTaxDetail;
        }
        return $this;
    }
    /**
     * Add item to ApplicableTaxDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ApplicableTaxDetail $item
     * @return \ArrayType\ArrayOfApplicableTaxDetail
     */
    public function addToApplicableTaxDetail(\StructType\ApplicableTaxDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ApplicableTaxDetail) {
            throw new \InvalidArgumentException(sprintf('The ApplicableTaxDetail property can only contain items of type \StructType\ApplicableTaxDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ApplicableTaxDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ApplicableTaxDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ApplicableTaxDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ApplicableTaxDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ApplicableTaxDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ApplicableTaxDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ApplicableTaxDetail
     */
    public function getAttributeName()
    {
        return 'ApplicableTaxDetail';
    }
}
