<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBundleServiceDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBundleServiceDetail
 * @subpackage Arrays
 */
class ArrayOfBundleServiceDetail extends AbstractStructArrayBase
{
    /**
     * The BundleServiceDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BundleServiceDetail[]
     */
    public $BundleServiceDetail;
    /**
     * Constructor method for ArrayOfBundleServiceDetail
     * @uses ArrayOfBundleServiceDetail::setBundleServiceDetail()
     * @param \StructType\BundleServiceDetail[] $bundleServiceDetail
     */
    public function __construct(array $bundleServiceDetail = array())
    {
        $this
            ->setBundleServiceDetail($bundleServiceDetail);
    }
    /**
     * Get BundleServiceDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BundleServiceDetail[]|null
     */
    public function getBundleServiceDetail()
    {
        return isset($this->BundleServiceDetail) ? $this->BundleServiceDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBundleServiceDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBundleServiceDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBundleServiceDetailForArrayConstraintsFromSetBundleServiceDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBundleServiceDetailBundleServiceDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfBundleServiceDetailBundleServiceDetailItem instanceof \StructType\BundleServiceDetail) {
                $invalidValues[] = is_object($arrayOfBundleServiceDetailBundleServiceDetailItem) ? get_class($arrayOfBundleServiceDetailBundleServiceDetailItem) : sprintf('%s(%s)', gettype($arrayOfBundleServiceDetailBundleServiceDetailItem), var_export($arrayOfBundleServiceDetailBundleServiceDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BundleServiceDetail property can only contain items of type \StructType\BundleServiceDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BundleServiceDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BundleServiceDetail[] $bundleServiceDetail
     * @return \ArrayType\ArrayOfBundleServiceDetail
     */
    public function setBundleServiceDetail(array $bundleServiceDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($bundleServiceDetailArrayErrorMessage = self::validateBundleServiceDetailForArrayConstraintsFromSetBundleServiceDetail($bundleServiceDetail))) {
            throw new \InvalidArgumentException($bundleServiceDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($bundleServiceDetail) || (is_array($bundleServiceDetail) && empty($bundleServiceDetail))) {
            unset($this->BundleServiceDetail);
        } else {
            $this->BundleServiceDetail = $bundleServiceDetail;
        }
        return $this;
    }
    /**
     * Add item to BundleServiceDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\BundleServiceDetail $item
     * @return \ArrayType\ArrayOfBundleServiceDetail
     */
    public function addToBundleServiceDetail(\StructType\BundleServiceDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BundleServiceDetail) {
            throw new \InvalidArgumentException(sprintf('The BundleServiceDetail property can only contain items of type \StructType\BundleServiceDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BundleServiceDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BundleServiceDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BundleServiceDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BundleServiceDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BundleServiceDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BundleServiceDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BundleServiceDetail
     */
    public function getAttributeName()
    {
        return 'BundleServiceDetail';
    }
}
