<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCombinableFlight ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCombinableFlight
 * @subpackage Arrays
 */
class ArrayOfCombinableFlight extends AbstractStructArrayBase
{
    /**
     * The CombinableFlight
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CombinableFlight[]
     */
    public $CombinableFlight;
    /**
     * Constructor method for ArrayOfCombinableFlight
     * @uses ArrayOfCombinableFlight::setCombinableFlight()
     * @param \StructType\CombinableFlight[] $combinableFlight
     */
    public function __construct(array $combinableFlight = array())
    {
        $this
            ->setCombinableFlight($combinableFlight);
    }
    /**
     * Get CombinableFlight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CombinableFlight[]|null
     */
    public function getCombinableFlight()
    {
        return isset($this->CombinableFlight) ? $this->CombinableFlight : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCombinableFlight method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCombinableFlight method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCombinableFlightForArrayConstraintsFromSetCombinableFlight(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCombinableFlightCombinableFlightItem) {
            // validation for constraint: itemType
            if (!$arrayOfCombinableFlightCombinableFlightItem instanceof \StructType\CombinableFlight) {
                $invalidValues[] = is_object($arrayOfCombinableFlightCombinableFlightItem) ? get_class($arrayOfCombinableFlightCombinableFlightItem) : sprintf('%s(%s)', gettype($arrayOfCombinableFlightCombinableFlightItem), var_export($arrayOfCombinableFlightCombinableFlightItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CombinableFlight property can only contain items of type \StructType\CombinableFlight, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CombinableFlight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CombinableFlight[] $combinableFlight
     * @return \ArrayType\ArrayOfCombinableFlight
     */
    public function setCombinableFlight(array $combinableFlight = array())
    {
        // validation for constraint: array
        if ('' !== ($combinableFlightArrayErrorMessage = self::validateCombinableFlightForArrayConstraintsFromSetCombinableFlight($combinableFlight))) {
            throw new \InvalidArgumentException($combinableFlightArrayErrorMessage, __LINE__);
        }
        if (is_null($combinableFlight) || (is_array($combinableFlight) && empty($combinableFlight))) {
            unset($this->CombinableFlight);
        } else {
            $this->CombinableFlight = $combinableFlight;
        }
        return $this;
    }
    /**
     * Add item to CombinableFlight value
     * @throws \InvalidArgumentException
     * @param \StructType\CombinableFlight $item
     * @return \ArrayType\ArrayOfCombinableFlight
     */
    public function addToCombinableFlight(\StructType\CombinableFlight $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CombinableFlight) {
            throw new \InvalidArgumentException(sprintf('The CombinableFlight property can only contain items of type \StructType\CombinableFlight, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CombinableFlight[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CombinableFlight|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CombinableFlight|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CombinableFlight|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CombinableFlight|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CombinableFlight|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CombinableFlight
     */
    public function getAttributeName()
    {
        return 'CombinableFlight';
    }
}
