<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCombinableTrip ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCombinableTrip
 * @subpackage Arrays
 */
class ArrayOfCombinableTrip extends AbstractStructArrayBase
{
    /**
     * The CombinableTrip
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CombinableTrip[]
     */
    public $CombinableTrip;
    /**
     * Constructor method for ArrayOfCombinableTrip
     * @uses ArrayOfCombinableTrip::setCombinableTrip()
     * @param \StructType\CombinableTrip[] $combinableTrip
     */
    public function __construct(array $combinableTrip = array())
    {
        $this
            ->setCombinableTrip($combinableTrip);
    }
    /**
     * Get CombinableTrip value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CombinableTrip[]|null
     */
    public function getCombinableTrip()
    {
        return isset($this->CombinableTrip) ? $this->CombinableTrip : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCombinableTrip method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCombinableTrip method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCombinableTripForArrayConstraintsFromSetCombinableTrip(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCombinableTripCombinableTripItem) {
            // validation for constraint: itemType
            if (!$arrayOfCombinableTripCombinableTripItem instanceof \StructType\CombinableTrip) {
                $invalidValues[] = is_object($arrayOfCombinableTripCombinableTripItem) ? get_class($arrayOfCombinableTripCombinableTripItem) : sprintf('%s(%s)', gettype($arrayOfCombinableTripCombinableTripItem), var_export($arrayOfCombinableTripCombinableTripItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CombinableTrip property can only contain items of type \StructType\CombinableTrip, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CombinableTrip value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CombinableTrip[] $combinableTrip
     * @return \ArrayType\ArrayOfCombinableTrip
     */
    public function setCombinableTrip(array $combinableTrip = array())
    {
        // validation for constraint: array
        if ('' !== ($combinableTripArrayErrorMessage = self::validateCombinableTripForArrayConstraintsFromSetCombinableTrip($combinableTrip))) {
            throw new \InvalidArgumentException($combinableTripArrayErrorMessage, __LINE__);
        }
        if (is_null($combinableTrip) || (is_array($combinableTrip) && empty($combinableTrip))) {
            unset($this->CombinableTrip);
        } else {
            $this->CombinableTrip = $combinableTrip;
        }
        return $this;
    }
    /**
     * Add item to CombinableTrip value
     * @throws \InvalidArgumentException
     * @param \StructType\CombinableTrip $item
     * @return \ArrayType\ArrayOfCombinableTrip
     */
    public function addToCombinableTrip(\StructType\CombinableTrip $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CombinableTrip) {
            throw new \InvalidArgumentException(sprintf('The CombinableTrip property can only contain items of type \StructType\CombinableTrip, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CombinableTrip[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CombinableTrip|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CombinableTrip|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CombinableTrip|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CombinableTrip|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CombinableTrip|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CombinableTrip
     */
    public function getAttributeName()
    {
        return 'CombinableTrip';
    }
}
