<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCombinedTripInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCombinedTripInfo
 * @subpackage Arrays
 */
class ArrayOfCombinedTripInfo extends AbstractStructArrayBase
{
    /**
     * The CombinedTripInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CombinedTripInfo[]
     */
    public $CombinedTripInfo;
    /**
     * Constructor method for ArrayOfCombinedTripInfo
     * @uses ArrayOfCombinedTripInfo::setCombinedTripInfo()
     * @param \StructType\CombinedTripInfo[] $combinedTripInfo
     */
    public function __construct(array $combinedTripInfo = array())
    {
        $this
            ->setCombinedTripInfo($combinedTripInfo);
    }
    /**
     * Get CombinedTripInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CombinedTripInfo[]|null
     */
    public function getCombinedTripInfo()
    {
        return isset($this->CombinedTripInfo) ? $this->CombinedTripInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCombinedTripInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCombinedTripInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCombinedTripInfoForArrayConstraintsFromSetCombinedTripInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCombinedTripInfoCombinedTripInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfCombinedTripInfoCombinedTripInfoItem instanceof \StructType\CombinedTripInfo) {
                $invalidValues[] = is_object($arrayOfCombinedTripInfoCombinedTripInfoItem) ? get_class($arrayOfCombinedTripInfoCombinedTripInfoItem) : sprintf('%s(%s)', gettype($arrayOfCombinedTripInfoCombinedTripInfoItem), var_export($arrayOfCombinedTripInfoCombinedTripInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CombinedTripInfo property can only contain items of type \StructType\CombinedTripInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CombinedTripInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CombinedTripInfo[] $combinedTripInfo
     * @return \ArrayType\ArrayOfCombinedTripInfo
     */
    public function setCombinedTripInfo(array $combinedTripInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($combinedTripInfoArrayErrorMessage = self::validateCombinedTripInfoForArrayConstraintsFromSetCombinedTripInfo($combinedTripInfo))) {
            throw new \InvalidArgumentException($combinedTripInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($combinedTripInfo) || (is_array($combinedTripInfo) && empty($combinedTripInfo))) {
            unset($this->CombinedTripInfo);
        } else {
            $this->CombinedTripInfo = $combinedTripInfo;
        }
        return $this;
    }
    /**
     * Add item to CombinedTripInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\CombinedTripInfo $item
     * @return \ArrayType\ArrayOfCombinedTripInfo
     */
    public function addToCombinedTripInfo(\StructType\CombinedTripInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CombinedTripInfo) {
            throw new \InvalidArgumentException(sprintf('The CombinedTripInfo property can only contain items of type \StructType\CombinedTripInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CombinedTripInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CombinedTripInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CombinedTripInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CombinedTripInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CombinedTripInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CombinedTripInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CombinedTripInfo
     */
    public function getAttributeName()
    {
        return 'CombinedTripInfo';
    }
}
