<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareAdjustmentDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareAdjustmentDetail
 * @subpackage Arrays
 */
class ArrayOfFareAdjustmentDetail extends AbstractStructArrayBase
{
    /**
     * The FareAdjustmentDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareAdjustmentDetail[]
     */
    public $FareAdjustmentDetail;
    /**
     * Constructor method for ArrayOfFareAdjustmentDetail
     * @uses ArrayOfFareAdjustmentDetail::setFareAdjustmentDetail()
     * @param \StructType\FareAdjustmentDetail[] $fareAdjustmentDetail
     */
    public function __construct(array $fareAdjustmentDetail = array())
    {
        $this
            ->setFareAdjustmentDetail($fareAdjustmentDetail);
    }
    /**
     * Get FareAdjustmentDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareAdjustmentDetail[]|null
     */
    public function getFareAdjustmentDetail()
    {
        return isset($this->FareAdjustmentDetail) ? $this->FareAdjustmentDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareAdjustmentDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareAdjustmentDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareAdjustmentDetailForArrayConstraintsFromSetFareAdjustmentDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareAdjustmentDetailFareAdjustmentDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareAdjustmentDetailFareAdjustmentDetailItem instanceof \StructType\FareAdjustmentDetail) {
                $invalidValues[] = is_object($arrayOfFareAdjustmentDetailFareAdjustmentDetailItem) ? get_class($arrayOfFareAdjustmentDetailFareAdjustmentDetailItem) : sprintf('%s(%s)', gettype($arrayOfFareAdjustmentDetailFareAdjustmentDetailItem), var_export($arrayOfFareAdjustmentDetailFareAdjustmentDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareAdjustmentDetail property can only contain items of type \StructType\FareAdjustmentDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareAdjustmentDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareAdjustmentDetail[] $fareAdjustmentDetail
     * @return \ArrayType\ArrayOfFareAdjustmentDetail
     */
    public function setFareAdjustmentDetail(array $fareAdjustmentDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($fareAdjustmentDetailArrayErrorMessage = self::validateFareAdjustmentDetailForArrayConstraintsFromSetFareAdjustmentDetail($fareAdjustmentDetail))) {
            throw new \InvalidArgumentException($fareAdjustmentDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($fareAdjustmentDetail) || (is_array($fareAdjustmentDetail) && empty($fareAdjustmentDetail))) {
            unset($this->FareAdjustmentDetail);
        } else {
            $this->FareAdjustmentDetail = $fareAdjustmentDetail;
        }
        return $this;
    }
    /**
     * Add item to FareAdjustmentDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\FareAdjustmentDetail $item
     * @return \ArrayType\ArrayOfFareAdjustmentDetail
     */
    public function addToFareAdjustmentDetail(\StructType\FareAdjustmentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareAdjustmentDetail) {
            throw new \InvalidArgumentException(sprintf('The FareAdjustmentDetail property can only contain items of type \StructType\FareAdjustmentDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareAdjustmentDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareAdjustmentDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareAdjustmentDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareAdjustmentDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareAdjustmentDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareAdjustmentDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareAdjustmentDetail
     */
    public function getAttributeName()
    {
        return 'FareAdjustmentDetail';
    }
}
