<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareDetail
 * @subpackage Arrays
 */
class ArrayOfFareDetail extends AbstractStructArrayBase
{
    /**
     * The FareDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareDetail[]
     */
    public $FareDetail;
    /**
     * Constructor method for ArrayOfFareDetail
     * @uses ArrayOfFareDetail::setFareDetail()
     * @param \StructType\FareDetail[] $fareDetail
     */
    public function __construct(array $fareDetail = array())
    {
        $this
            ->setFareDetail($fareDetail);
    }
    /**
     * Get FareDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareDetail[]|null
     */
    public function getFareDetail()
    {
        return isset($this->FareDetail) ? $this->FareDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareDetailForArrayConstraintsFromSetFareDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareDetailFareDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareDetailFareDetailItem instanceof \StructType\FareDetail) {
                $invalidValues[] = is_object($arrayOfFareDetailFareDetailItem) ? get_class($arrayOfFareDetailFareDetailItem) : sprintf('%s(%s)', gettype($arrayOfFareDetailFareDetailItem), var_export($arrayOfFareDetailFareDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareDetail property can only contain items of type \StructType\FareDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareDetail[] $fareDetail
     * @return \ArrayType\ArrayOfFareDetail
     */
    public function setFareDetail(array $fareDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($fareDetailArrayErrorMessage = self::validateFareDetailForArrayConstraintsFromSetFareDetail($fareDetail))) {
            throw new \InvalidArgumentException($fareDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($fareDetail) || (is_array($fareDetail) && empty($fareDetail))) {
            unset($this->FareDetail);
        } else {
            $this->FareDetail = $fareDetail;
        }
        return $this;
    }
    /**
     * Add item to FareDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\FareDetail $item
     * @return \ArrayType\ArrayOfFareDetail
     */
    public function addToFareDetail(\StructType\FareDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareDetail) {
            throw new \InvalidArgumentException(sprintf('The FareDetail property can only contain items of type \StructType\FareDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareDetail
     */
    public function getAttributeName()
    {
        return 'FareDetail';
    }
}
