<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareQuoteDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareQuoteDetail
 * @subpackage Arrays
 */
class ArrayOfFareQuoteDetail extends AbstractStructArrayBase
{
    /**
     * The FareQuoteDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareQuoteDetail[]
     */
    public $FareQuoteDetail;
    /**
     * Constructor method for ArrayOfFareQuoteDetail
     * @uses ArrayOfFareQuoteDetail::setFareQuoteDetail()
     * @param \StructType\FareQuoteDetail[] $fareQuoteDetail
     */
    public function __construct(array $fareQuoteDetail = array())
    {
        $this
            ->setFareQuoteDetail($fareQuoteDetail);
    }
    /**
     * Get FareQuoteDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareQuoteDetail[]|null
     */
    public function getFareQuoteDetail()
    {
        return isset($this->FareQuoteDetail) ? $this->FareQuoteDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareQuoteDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareQuoteDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareQuoteDetailForArrayConstraintsFromSetFareQuoteDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareQuoteDetailFareQuoteDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareQuoteDetailFareQuoteDetailItem instanceof \StructType\FareQuoteDetail) {
                $invalidValues[] = is_object($arrayOfFareQuoteDetailFareQuoteDetailItem) ? get_class($arrayOfFareQuoteDetailFareQuoteDetailItem) : sprintf('%s(%s)', gettype($arrayOfFareQuoteDetailFareQuoteDetailItem), var_export($arrayOfFareQuoteDetailFareQuoteDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareQuoteDetail property can only contain items of type \StructType\FareQuoteDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareQuoteDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareQuoteDetail[] $fareQuoteDetail
     * @return \ArrayType\ArrayOfFareQuoteDetail
     */
    public function setFareQuoteDetail(array $fareQuoteDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($fareQuoteDetailArrayErrorMessage = self::validateFareQuoteDetailForArrayConstraintsFromSetFareQuoteDetail($fareQuoteDetail))) {
            throw new \InvalidArgumentException($fareQuoteDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($fareQuoteDetail) || (is_array($fareQuoteDetail) && empty($fareQuoteDetail))) {
            unset($this->FareQuoteDetail);
        } else {
            $this->FareQuoteDetail = $fareQuoteDetail;
        }
        return $this;
    }
    /**
     * Add item to FareQuoteDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\FareQuoteDetail $item
     * @return \ArrayType\ArrayOfFareQuoteDetail
     */
    public function addToFareQuoteDetail(\StructType\FareQuoteDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareQuoteDetail) {
            throw new \InvalidArgumentException(sprintf('The FareQuoteDetail property can only contain items of type \StructType\FareQuoteDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareQuoteDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareQuoteDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareQuoteDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareQuoteDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareQuoteDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareQuoteDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareQuoteDetail
     */
    public function getAttributeName()
    {
        return 'FareQuoteDetail';
    }
}
