<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareQuoteDetailDateRange ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareQuoteDetailDateRange
 * @subpackage Arrays
 */
class ArrayOfFareQuoteDetailDateRange extends AbstractStructArrayBase
{
    /**
     * The FareQuoteDetailDateRange
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareQuoteDetailDateRange[]
     */
    public $FareQuoteDetailDateRange;
    /**
     * Constructor method for ArrayOfFareQuoteDetailDateRange
     * @uses ArrayOfFareQuoteDetailDateRange::setFareQuoteDetailDateRange()
     * @param \StructType\FareQuoteDetailDateRange[] $fareQuoteDetailDateRange
     */
    public function __construct(array $fareQuoteDetailDateRange = array())
    {
        $this
            ->setFareQuoteDetailDateRange($fareQuoteDetailDateRange);
    }
    /**
     * Get FareQuoteDetailDateRange value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareQuoteDetailDateRange[]|null
     */
    public function getFareQuoteDetailDateRange()
    {
        return isset($this->FareQuoteDetailDateRange) ? $this->FareQuoteDetailDateRange : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareQuoteDetailDateRange method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareQuoteDetailDateRange method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareQuoteDetailDateRangeForArrayConstraintsFromSetFareQuoteDetailDateRange(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareQuoteDetailDateRangeFareQuoteDetailDateRangeItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareQuoteDetailDateRangeFareQuoteDetailDateRangeItem instanceof \StructType\FareQuoteDetailDateRange) {
                $invalidValues[] = is_object($arrayOfFareQuoteDetailDateRangeFareQuoteDetailDateRangeItem) ? get_class($arrayOfFareQuoteDetailDateRangeFareQuoteDetailDateRangeItem) : sprintf('%s(%s)', gettype($arrayOfFareQuoteDetailDateRangeFareQuoteDetailDateRangeItem), var_export($arrayOfFareQuoteDetailDateRangeFareQuoteDetailDateRangeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareQuoteDetailDateRange property can only contain items of type \StructType\FareQuoteDetailDateRange, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareQuoteDetailDateRange value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareQuoteDetailDateRange[] $fareQuoteDetailDateRange
     * @return \ArrayType\ArrayOfFareQuoteDetailDateRange
     */
    public function setFareQuoteDetailDateRange(array $fareQuoteDetailDateRange = array())
    {
        // validation for constraint: array
        if ('' !== ($fareQuoteDetailDateRangeArrayErrorMessage = self::validateFareQuoteDetailDateRangeForArrayConstraintsFromSetFareQuoteDetailDateRange($fareQuoteDetailDateRange))) {
            throw new \InvalidArgumentException($fareQuoteDetailDateRangeArrayErrorMessage, __LINE__);
        }
        if (is_null($fareQuoteDetailDateRange) || (is_array($fareQuoteDetailDateRange) && empty($fareQuoteDetailDateRange))) {
            unset($this->FareQuoteDetailDateRange);
        } else {
            $this->FareQuoteDetailDateRange = $fareQuoteDetailDateRange;
        }
        return $this;
    }
    /**
     * Add item to FareQuoteDetailDateRange value
     * @throws \InvalidArgumentException
     * @param \StructType\FareQuoteDetailDateRange $item
     * @return \ArrayType\ArrayOfFareQuoteDetailDateRange
     */
    public function addToFareQuoteDetailDateRange(\StructType\FareQuoteDetailDateRange $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareQuoteDetailDateRange) {
            throw new \InvalidArgumentException(sprintf('The FareQuoteDetailDateRange property can only contain items of type \StructType\FareQuoteDetailDateRange, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareQuoteDetailDateRange[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareQuoteDetailDateRange|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareQuoteDetailDateRange|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareQuoteDetailDateRange|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareQuoteDetailDateRange|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareQuoteDetailDateRange|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareQuoteDetailDateRange
     */
    public function getAttributeName()
    {
        return 'FareQuoteDetailDateRange';
    }
}
