<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareQuoteRequestInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareQuoteRequestInfo
 * @subpackage Arrays
 */
class ArrayOfFareQuoteRequestInfo extends AbstractStructArrayBase
{
    /**
     * The FareQuoteRequestInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareQuoteRequestInfo[]
     */
    public $FareQuoteRequestInfo;
    /**
     * Constructor method for ArrayOfFareQuoteRequestInfo
     * @uses ArrayOfFareQuoteRequestInfo::setFareQuoteRequestInfo()
     * @param \StructType\FareQuoteRequestInfo[] $fareQuoteRequestInfo
     */
    public function __construct(array $fareQuoteRequestInfo = array())
    {
        $this
            ->setFareQuoteRequestInfo($fareQuoteRequestInfo);
    }
    /**
     * Get FareQuoteRequestInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareQuoteRequestInfo[]|null
     */
    public function getFareQuoteRequestInfo()
    {
        return isset($this->FareQuoteRequestInfo) ? $this->FareQuoteRequestInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareQuoteRequestInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareQuoteRequestInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareQuoteRequestInfoForArrayConstraintsFromSetFareQuoteRequestInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareQuoteRequestInfoFareQuoteRequestInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareQuoteRequestInfoFareQuoteRequestInfoItem instanceof \StructType\FareQuoteRequestInfo) {
                $invalidValues[] = is_object($arrayOfFareQuoteRequestInfoFareQuoteRequestInfoItem) ? get_class($arrayOfFareQuoteRequestInfoFareQuoteRequestInfoItem) : sprintf('%s(%s)', gettype($arrayOfFareQuoteRequestInfoFareQuoteRequestInfoItem), var_export($arrayOfFareQuoteRequestInfoFareQuoteRequestInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareQuoteRequestInfo property can only contain items of type \StructType\FareQuoteRequestInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareQuoteRequestInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareQuoteRequestInfo[] $fareQuoteRequestInfo
     * @return \ArrayType\ArrayOfFareQuoteRequestInfo
     */
    public function setFareQuoteRequestInfo(array $fareQuoteRequestInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($fareQuoteRequestInfoArrayErrorMessage = self::validateFareQuoteRequestInfoForArrayConstraintsFromSetFareQuoteRequestInfo($fareQuoteRequestInfo))) {
            throw new \InvalidArgumentException($fareQuoteRequestInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($fareQuoteRequestInfo) || (is_array($fareQuoteRequestInfo) && empty($fareQuoteRequestInfo))) {
            unset($this->FareQuoteRequestInfo);
        } else {
            $this->FareQuoteRequestInfo = $fareQuoteRequestInfo;
        }
        return $this;
    }
    /**
     * Add item to FareQuoteRequestInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\FareQuoteRequestInfo $item
     * @return \ArrayType\ArrayOfFareQuoteRequestInfo
     */
    public function addToFareQuoteRequestInfo(\StructType\FareQuoteRequestInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareQuoteRequestInfo) {
            throw new \InvalidArgumentException(sprintf('The FareQuoteRequestInfo property can only contain items of type \StructType\FareQuoteRequestInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareQuoteRequestInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareQuoteRequestInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareQuoteRequestInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareQuoteRequestInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareQuoteRequestInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareQuoteRequestInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareQuoteRequestInfo
     */
    public function getAttributeName()
    {
        return 'FareQuoteRequestInfo';
    }
}
