<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareShopAdjustmentDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareShopAdjustmentDetail
 * @subpackage Arrays
 */
class ArrayOfFareShopAdjustmentDetail extends AbstractStructArrayBase
{
    /**
     * The FareShopAdjustmentDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareShopAdjustmentDetail[]
     */
    public $FareShopAdjustmentDetail;
    /**
     * Constructor method for ArrayOfFareShopAdjustmentDetail
     * @uses ArrayOfFareShopAdjustmentDetail::setFareShopAdjustmentDetail()
     * @param \StructType\FareShopAdjustmentDetail[] $fareShopAdjustmentDetail
     */
    public function __construct(array $fareShopAdjustmentDetail = array())
    {
        $this
            ->setFareShopAdjustmentDetail($fareShopAdjustmentDetail);
    }
    /**
     * Get FareShopAdjustmentDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareShopAdjustmentDetail[]|null
     */
    public function getFareShopAdjustmentDetail()
    {
        return isset($this->FareShopAdjustmentDetail) ? $this->FareShopAdjustmentDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareShopAdjustmentDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareShopAdjustmentDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareShopAdjustmentDetailForArrayConstraintsFromSetFareShopAdjustmentDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareShopAdjustmentDetailFareShopAdjustmentDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareShopAdjustmentDetailFareShopAdjustmentDetailItem instanceof \StructType\FareShopAdjustmentDetail) {
                $invalidValues[] = is_object($arrayOfFareShopAdjustmentDetailFareShopAdjustmentDetailItem) ? get_class($arrayOfFareShopAdjustmentDetailFareShopAdjustmentDetailItem) : sprintf('%s(%s)', gettype($arrayOfFareShopAdjustmentDetailFareShopAdjustmentDetailItem), var_export($arrayOfFareShopAdjustmentDetailFareShopAdjustmentDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareShopAdjustmentDetail property can only contain items of type \StructType\FareShopAdjustmentDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareShopAdjustmentDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareShopAdjustmentDetail[] $fareShopAdjustmentDetail
     * @return \ArrayType\ArrayOfFareShopAdjustmentDetail
     */
    public function setFareShopAdjustmentDetail(array $fareShopAdjustmentDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($fareShopAdjustmentDetailArrayErrorMessage = self::validateFareShopAdjustmentDetailForArrayConstraintsFromSetFareShopAdjustmentDetail($fareShopAdjustmentDetail))) {
            throw new \InvalidArgumentException($fareShopAdjustmentDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($fareShopAdjustmentDetail) || (is_array($fareShopAdjustmentDetail) && empty($fareShopAdjustmentDetail))) {
            unset($this->FareShopAdjustmentDetail);
        } else {
            $this->FareShopAdjustmentDetail = $fareShopAdjustmentDetail;
        }
        return $this;
    }
    /**
     * Add item to FareShopAdjustmentDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\FareShopAdjustmentDetail $item
     * @return \ArrayType\ArrayOfFareShopAdjustmentDetail
     */
    public function addToFareShopAdjustmentDetail(\StructType\FareShopAdjustmentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareShopAdjustmentDetail) {
            throw new \InvalidArgumentException(sprintf('The FareShopAdjustmentDetail property can only contain items of type \StructType\FareShopAdjustmentDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareShopAdjustmentDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareShopAdjustmentDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareShopAdjustmentDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareShopAdjustmentDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareShopAdjustmentDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareShopAdjustmentDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareShopAdjustmentDetail
     */
    public function getAttributeName()
    {
        return 'FareShopAdjustmentDetail';
    }
}
