<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareType
 * @subpackage Arrays
 */
class ArrayOfFareType extends AbstractStructArrayBase
{
    /**
     * The FareType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareType[]
     */
    public $FareType;
    /**
     * Constructor method for ArrayOfFareType
     * @uses ArrayOfFareType::setFareType()
     * @param \StructType\FareType[] $fareType
     */
    public function __construct(array $fareType = array())
    {
        $this
            ->setFareType($fareType);
    }
    /**
     * Get FareType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareType[]|null
     */
    public function getFareType()
    {
        return isset($this->FareType) ? $this->FareType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareTypeForArrayConstraintsFromSetFareType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareTypeFareTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareTypeFareTypeItem instanceof \StructType\FareType) {
                $invalidValues[] = is_object($arrayOfFareTypeFareTypeItem) ? get_class($arrayOfFareTypeFareTypeItem) : sprintf('%s(%s)', gettype($arrayOfFareTypeFareTypeItem), var_export($arrayOfFareTypeFareTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareType property can only contain items of type \StructType\FareType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareType[] $fareType
     * @return \ArrayType\ArrayOfFareType
     */
    public function setFareType(array $fareType = array())
    {
        // validation for constraint: array
        if ('' !== ($fareTypeArrayErrorMessage = self::validateFareTypeForArrayConstraintsFromSetFareType($fareType))) {
            throw new \InvalidArgumentException($fareTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($fareType) || (is_array($fareType) && empty($fareType))) {
            unset($this->FareType);
        } else {
            $this->FareType = $fareType;
        }
        return $this;
    }
    /**
     * Add item to FareType value
     * @throws \InvalidArgumentException
     * @param \StructType\FareType $item
     * @return \ArrayType\ArrayOfFareType
     */
    public function addToFareType(\StructType\FareType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareType) {
            throw new \InvalidArgumentException(sprintf('The FareType property can only contain items of type \StructType\FareType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareType
     */
    public function getAttributeName()
    {
        return 'FareType';
    }
}
