<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareTypeInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareTypeInfo
 * @subpackage Arrays
 */
class ArrayOfFareTypeInfo extends AbstractStructArrayBase
{
    /**
     * The FareTypeInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareTypeInfo[]
     */
    public $FareTypeInfo;
    /**
     * Constructor method for ArrayOfFareTypeInfo
     * @uses ArrayOfFareTypeInfo::setFareTypeInfo()
     * @param \StructType\FareTypeInfo[] $fareTypeInfo
     */
    public function __construct(array $fareTypeInfo = array())
    {
        $this
            ->setFareTypeInfo($fareTypeInfo);
    }
    /**
     * Get FareTypeInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareTypeInfo[]|null
     */
    public function getFareTypeInfo()
    {
        return isset($this->FareTypeInfo) ? $this->FareTypeInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareTypeInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareTypeInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareTypeInfoForArrayConstraintsFromSetFareTypeInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareTypeInfoFareTypeInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareTypeInfoFareTypeInfoItem instanceof \StructType\FareTypeInfo) {
                $invalidValues[] = is_object($arrayOfFareTypeInfoFareTypeInfoItem) ? get_class($arrayOfFareTypeInfoFareTypeInfoItem) : sprintf('%s(%s)', gettype($arrayOfFareTypeInfoFareTypeInfoItem), var_export($arrayOfFareTypeInfoFareTypeInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareTypeInfo property can only contain items of type \StructType\FareTypeInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareTypeInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareTypeInfo[] $fareTypeInfo
     * @return \ArrayType\ArrayOfFareTypeInfo
     */
    public function setFareTypeInfo(array $fareTypeInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($fareTypeInfoArrayErrorMessage = self::validateFareTypeInfoForArrayConstraintsFromSetFareTypeInfo($fareTypeInfo))) {
            throw new \InvalidArgumentException($fareTypeInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($fareTypeInfo) || (is_array($fareTypeInfo) && empty($fareTypeInfo))) {
            unset($this->FareTypeInfo);
        } else {
            $this->FareTypeInfo = $fareTypeInfo;
        }
        return $this;
    }
    /**
     * Add item to FareTypeInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\FareTypeInfo $item
     * @return \ArrayType\ArrayOfFareTypeInfo
     */
    public function addToFareTypeInfo(\StructType\FareTypeInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareTypeInfo) {
            throw new \InvalidArgumentException(sprintf('The FareTypeInfo property can only contain items of type \StructType\FareTypeInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareTypeInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareTypeInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareTypeInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareTypeInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareTypeInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareTypeInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareTypeInfo
     */
    public function getAttributeName()
    {
        return 'FareTypeInfo';
    }
}
