<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFastFareSearchTravelerInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFastFareSearchTravelerInfo
 * @subpackage Arrays
 */
class ArrayOfFastFareSearchTravelerInfo extends AbstractStructArrayBase
{
    /**
     * The FastFareSearchTravelerInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FastFareSearchTravelerInfo[]
     */
    public $FastFareSearchTravelerInfo;
    /**
     * Constructor method for ArrayOfFastFareSearchTravelerInfo
     * @uses ArrayOfFastFareSearchTravelerInfo::setFastFareSearchTravelerInfo()
     * @param \StructType\FastFareSearchTravelerInfo[] $fastFareSearchTravelerInfo
     */
    public function __construct(array $fastFareSearchTravelerInfo = array())
    {
        $this
            ->setFastFareSearchTravelerInfo($fastFareSearchTravelerInfo);
    }
    /**
     * Get FastFareSearchTravelerInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FastFareSearchTravelerInfo[]|null
     */
    public function getFastFareSearchTravelerInfo()
    {
        return isset($this->FastFareSearchTravelerInfo) ? $this->FastFareSearchTravelerInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFastFareSearchTravelerInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFastFareSearchTravelerInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFastFareSearchTravelerInfoForArrayConstraintsFromSetFastFareSearchTravelerInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFastFareSearchTravelerInfoFastFareSearchTravelerInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfFastFareSearchTravelerInfoFastFareSearchTravelerInfoItem instanceof \StructType\FastFareSearchTravelerInfo) {
                $invalidValues[] = is_object($arrayOfFastFareSearchTravelerInfoFastFareSearchTravelerInfoItem) ? get_class($arrayOfFastFareSearchTravelerInfoFastFareSearchTravelerInfoItem) : sprintf('%s(%s)', gettype($arrayOfFastFareSearchTravelerInfoFastFareSearchTravelerInfoItem), var_export($arrayOfFastFareSearchTravelerInfoFastFareSearchTravelerInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FastFareSearchTravelerInfo property can only contain items of type \StructType\FastFareSearchTravelerInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FastFareSearchTravelerInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FastFareSearchTravelerInfo[] $fastFareSearchTravelerInfo
     * @return \ArrayType\ArrayOfFastFareSearchTravelerInfo
     */
    public function setFastFareSearchTravelerInfo(array $fastFareSearchTravelerInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($fastFareSearchTravelerInfoArrayErrorMessage = self::validateFastFareSearchTravelerInfoForArrayConstraintsFromSetFastFareSearchTravelerInfo($fastFareSearchTravelerInfo))) {
            throw new \InvalidArgumentException($fastFareSearchTravelerInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($fastFareSearchTravelerInfo) || (is_array($fastFareSearchTravelerInfo) && empty($fastFareSearchTravelerInfo))) {
            unset($this->FastFareSearchTravelerInfo);
        } else {
            $this->FastFareSearchTravelerInfo = $fastFareSearchTravelerInfo;
        }
        return $this;
    }
    /**
     * Add item to FastFareSearchTravelerInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\FastFareSearchTravelerInfo $item
     * @return \ArrayType\ArrayOfFastFareSearchTravelerInfo
     */
    public function addToFastFareSearchTravelerInfo(\StructType\FastFareSearchTravelerInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FastFareSearchTravelerInfo) {
            throw new \InvalidArgumentException(sprintf('The FastFareSearchTravelerInfo property can only contain items of type \StructType\FastFareSearchTravelerInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FastFareSearchTravelerInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FastFareSearchTravelerInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FastFareSearchTravelerInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FastFareSearchTravelerInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FastFareSearchTravelerInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FastFareSearchTravelerInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FastFareSearchTravelerInfo
     */
    public function getAttributeName()
    {
        return 'FastFareSearchTravelerInfo';
    }
}
