<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFastFareSearchTripDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFastFareSearchTripDetail
 * @subpackage Arrays
 */
class ArrayOfFastFareSearchTripDetail extends AbstractStructArrayBase
{
    /**
     * The FastFareSearchTripDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FastFareSearchTripDetail[]
     */
    public $FastFareSearchTripDetail;
    /**
     * Constructor method for ArrayOfFastFareSearchTripDetail
     * @uses ArrayOfFastFareSearchTripDetail::setFastFareSearchTripDetail()
     * @param \StructType\FastFareSearchTripDetail[] $fastFareSearchTripDetail
     */
    public function __construct(array $fastFareSearchTripDetail = array())
    {
        $this
            ->setFastFareSearchTripDetail($fastFareSearchTripDetail);
    }
    /**
     * Get FastFareSearchTripDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FastFareSearchTripDetail[]|null
     */
    public function getFastFareSearchTripDetail()
    {
        return isset($this->FastFareSearchTripDetail) ? $this->FastFareSearchTripDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFastFareSearchTripDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFastFareSearchTripDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFastFareSearchTripDetailForArrayConstraintsFromSetFastFareSearchTripDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFastFareSearchTripDetailFastFareSearchTripDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfFastFareSearchTripDetailFastFareSearchTripDetailItem instanceof \StructType\FastFareSearchTripDetail) {
                $invalidValues[] = is_object($arrayOfFastFareSearchTripDetailFastFareSearchTripDetailItem) ? get_class($arrayOfFastFareSearchTripDetailFastFareSearchTripDetailItem) : sprintf('%s(%s)', gettype($arrayOfFastFareSearchTripDetailFastFareSearchTripDetailItem), var_export($arrayOfFastFareSearchTripDetailFastFareSearchTripDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FastFareSearchTripDetail property can only contain items of type \StructType\FastFareSearchTripDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FastFareSearchTripDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FastFareSearchTripDetail[] $fastFareSearchTripDetail
     * @return \ArrayType\ArrayOfFastFareSearchTripDetail
     */
    public function setFastFareSearchTripDetail(array $fastFareSearchTripDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($fastFareSearchTripDetailArrayErrorMessage = self::validateFastFareSearchTripDetailForArrayConstraintsFromSetFastFareSearchTripDetail($fastFareSearchTripDetail))) {
            throw new \InvalidArgumentException($fastFareSearchTripDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($fastFareSearchTripDetail) || (is_array($fastFareSearchTripDetail) && empty($fastFareSearchTripDetail))) {
            unset($this->FastFareSearchTripDetail);
        } else {
            $this->FastFareSearchTripDetail = $fastFareSearchTripDetail;
        }
        return $this;
    }
    /**
     * Add item to FastFareSearchTripDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\FastFareSearchTripDetail $item
     * @return \ArrayType\ArrayOfFastFareSearchTripDetail
     */
    public function addToFastFareSearchTripDetail(\StructType\FastFareSearchTripDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FastFareSearchTripDetail) {
            throw new \InvalidArgumentException(sprintf('The FastFareSearchTripDetail property can only contain items of type \StructType\FastFareSearchTripDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FastFareSearchTripDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FastFareSearchTripDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FastFareSearchTripDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FastFareSearchTripDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FastFareSearchTripDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FastFareSearchTripDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FastFareSearchTripDetail
     */
    public function getAttributeName()
    {
        return 'FastFareSearchTripDetail';
    }
}
