<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFlightDetail
 * @subpackage Arrays
 */
class ArrayOfFlightDetail extends AbstractStructArrayBase
{
    /**
     * The FlightDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FlightDetail[]
     */
    public $FlightDetail;
    /**
     * Constructor method for ArrayOfFlightDetail
     * @uses ArrayOfFlightDetail::setFlightDetail()
     * @param \StructType\FlightDetail[] $flightDetail
     */
    public function __construct(array $flightDetail = array())
    {
        $this
            ->setFlightDetail($flightDetail);
    }
    /**
     * Get FlightDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FlightDetail[]|null
     */
    public function getFlightDetail()
    {
        return isset($this->FlightDetail) ? $this->FlightDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightDetailForArrayConstraintsFromSetFlightDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFlightDetailFlightDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightDetailFlightDetailItem instanceof \StructType\FlightDetail) {
                $invalidValues[] = is_object($arrayOfFlightDetailFlightDetailItem) ? get_class($arrayOfFlightDetailFlightDetailItem) : sprintf('%s(%s)', gettype($arrayOfFlightDetailFlightDetailItem), var_export($arrayOfFlightDetailFlightDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightDetail property can only contain items of type \StructType\FlightDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FlightDetail[] $flightDetail
     * @return \ArrayType\ArrayOfFlightDetail
     */
    public function setFlightDetail(array $flightDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($flightDetailArrayErrorMessage = self::validateFlightDetailForArrayConstraintsFromSetFlightDetail($flightDetail))) {
            throw new \InvalidArgumentException($flightDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($flightDetail) || (is_array($flightDetail) && empty($flightDetail))) {
            unset($this->FlightDetail);
        } else {
            $this->FlightDetail = $flightDetail;
        }
        return $this;
    }
    /**
     * Add item to FlightDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\FlightDetail $item
     * @return \ArrayType\ArrayOfFlightDetail
     */
    public function addToFlightDetail(\StructType\FlightDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FlightDetail) {
            throw new \InvalidArgumentException(sprintf('The FlightDetail property can only contain items of type \StructType\FlightDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FlightDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FlightDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FlightDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FlightDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FlightDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightDetail
     */
    public function getAttributeName()
    {
        return 'FlightDetail';
    }
}
