<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightLegDetailed ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFlightLegDetailed
 * @subpackage Arrays
 */
class ArrayOfFlightLegDetailed extends AbstractStructArrayBase
{
    /**
     * The FlightLegDetailed
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FlightLegDetailed[]
     */
    public $FlightLegDetailed;
    /**
     * Constructor method for ArrayOfFlightLegDetailed
     * @uses ArrayOfFlightLegDetailed::setFlightLegDetailed()
     * @param \StructType\FlightLegDetailed[] $flightLegDetailed
     */
    public function __construct(array $flightLegDetailed = array())
    {
        $this
            ->setFlightLegDetailed($flightLegDetailed);
    }
    /**
     * Get FlightLegDetailed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FlightLegDetailed[]|null
     */
    public function getFlightLegDetailed()
    {
        return isset($this->FlightLegDetailed) ? $this->FlightLegDetailed : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightLegDetailed method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightLegDetailed method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightLegDetailedForArrayConstraintsFromSetFlightLegDetailed(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFlightLegDetailedFlightLegDetailedItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightLegDetailedFlightLegDetailedItem instanceof \StructType\FlightLegDetailed) {
                $invalidValues[] = is_object($arrayOfFlightLegDetailedFlightLegDetailedItem) ? get_class($arrayOfFlightLegDetailedFlightLegDetailedItem) : sprintf('%s(%s)', gettype($arrayOfFlightLegDetailedFlightLegDetailedItem), var_export($arrayOfFlightLegDetailedFlightLegDetailedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightLegDetailed property can only contain items of type \StructType\FlightLegDetailed, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightLegDetailed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FlightLegDetailed[] $flightLegDetailed
     * @return \ArrayType\ArrayOfFlightLegDetailed
     */
    public function setFlightLegDetailed(array $flightLegDetailed = array())
    {
        // validation for constraint: array
        if ('' !== ($flightLegDetailedArrayErrorMessage = self::validateFlightLegDetailedForArrayConstraintsFromSetFlightLegDetailed($flightLegDetailed))) {
            throw new \InvalidArgumentException($flightLegDetailedArrayErrorMessage, __LINE__);
        }
        if (is_null($flightLegDetailed) || (is_array($flightLegDetailed) && empty($flightLegDetailed))) {
            unset($this->FlightLegDetailed);
        } else {
            $this->FlightLegDetailed = $flightLegDetailed;
        }
        return $this;
    }
    /**
     * Add item to FlightLegDetailed value
     * @throws \InvalidArgumentException
     * @param \StructType\FlightLegDetailed $item
     * @return \ArrayType\ArrayOfFlightLegDetailed
     */
    public function addToFlightLegDetailed(\StructType\FlightLegDetailed $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FlightLegDetailed) {
            throw new \InvalidArgumentException(sprintf('The FlightLegDetailed property can only contain items of type \StructType\FlightLegDetailed, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightLegDetailed[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FlightLegDetailed|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FlightLegDetailed|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FlightLegDetailed|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FlightLegDetailed|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FlightLegDetailed|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightLegDetailed
     */
    public function getAttributeName()
    {
        return 'FlightLegDetailed';
    }
}
