<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLegDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLegDetail
 * @subpackage Arrays
 */
class ArrayOfLegDetail extends AbstractStructArrayBase
{
    /**
     * The LegDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LegDetail[]
     */
    public $LegDetail;
    /**
     * Constructor method for ArrayOfLegDetail
     * @uses ArrayOfLegDetail::setLegDetail()
     * @param \StructType\LegDetail[] $legDetail
     */
    public function __construct(array $legDetail = array())
    {
        $this
            ->setLegDetail($legDetail);
    }
    /**
     * Get LegDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LegDetail[]|null
     */
    public function getLegDetail()
    {
        return isset($this->LegDetail) ? $this->LegDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLegDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLegDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLegDetailForArrayConstraintsFromSetLegDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLegDetailLegDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfLegDetailLegDetailItem instanceof \StructType\LegDetail) {
                $invalidValues[] = is_object($arrayOfLegDetailLegDetailItem) ? get_class($arrayOfLegDetailLegDetailItem) : sprintf('%s(%s)', gettype($arrayOfLegDetailLegDetailItem), var_export($arrayOfLegDetailLegDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LegDetail property can only contain items of type \StructType\LegDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LegDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LegDetail[] $legDetail
     * @return \ArrayType\ArrayOfLegDetail
     */
    public function setLegDetail(array $legDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($legDetailArrayErrorMessage = self::validateLegDetailForArrayConstraintsFromSetLegDetail($legDetail))) {
            throw new \InvalidArgumentException($legDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($legDetail) || (is_array($legDetail) && empty($legDetail))) {
            unset($this->LegDetail);
        } else {
            $this->LegDetail = $legDetail;
        }
        return $this;
    }
    /**
     * Add item to LegDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\LegDetail $item
     * @return \ArrayType\ArrayOfLegDetail
     */
    public function addToLegDetail(\StructType\LegDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LegDetail) {
            throw new \InvalidArgumentException(sprintf('The LegDetail property can only contain items of type \StructType\LegDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LegDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LegDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LegDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LegDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LegDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LegDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LegDetail
     */
    public function getAttributeName()
    {
        return 'LegDetail';
    }
}
