<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLegDetailIdentifier ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLegDetailIdentifier
 * @subpackage Arrays
 */
class ArrayOfLegDetailIdentifier extends AbstractStructArrayBase
{
    /**
     * The LegDetailIdentifier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LegDetailIdentifier[]
     */
    public $LegDetailIdentifier;
    /**
     * Constructor method for ArrayOfLegDetailIdentifier
     * @uses ArrayOfLegDetailIdentifier::setLegDetailIdentifier()
     * @param \StructType\LegDetailIdentifier[] $legDetailIdentifier
     */
    public function __construct(array $legDetailIdentifier = array())
    {
        $this
            ->setLegDetailIdentifier($legDetailIdentifier);
    }
    /**
     * Get LegDetailIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LegDetailIdentifier[]|null
     */
    public function getLegDetailIdentifier()
    {
        return isset($this->LegDetailIdentifier) ? $this->LegDetailIdentifier : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLegDetailIdentifier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLegDetailIdentifier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLegDetailIdentifierForArrayConstraintsFromSetLegDetailIdentifier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLegDetailIdentifierLegDetailIdentifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfLegDetailIdentifierLegDetailIdentifierItem instanceof \StructType\LegDetailIdentifier) {
                $invalidValues[] = is_object($arrayOfLegDetailIdentifierLegDetailIdentifierItem) ? get_class($arrayOfLegDetailIdentifierLegDetailIdentifierItem) : sprintf('%s(%s)', gettype($arrayOfLegDetailIdentifierLegDetailIdentifierItem), var_export($arrayOfLegDetailIdentifierLegDetailIdentifierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LegDetailIdentifier property can only contain items of type \StructType\LegDetailIdentifier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LegDetailIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LegDetailIdentifier[] $legDetailIdentifier
     * @return \ArrayType\ArrayOfLegDetailIdentifier
     */
    public function setLegDetailIdentifier(array $legDetailIdentifier = array())
    {
        // validation for constraint: array
        if ('' !== ($legDetailIdentifierArrayErrorMessage = self::validateLegDetailIdentifierForArrayConstraintsFromSetLegDetailIdentifier($legDetailIdentifier))) {
            throw new \InvalidArgumentException($legDetailIdentifierArrayErrorMessage, __LINE__);
        }
        if (is_null($legDetailIdentifier) || (is_array($legDetailIdentifier) && empty($legDetailIdentifier))) {
            unset($this->LegDetailIdentifier);
        } else {
            $this->LegDetailIdentifier = $legDetailIdentifier;
        }
        return $this;
    }
    /**
     * Add item to LegDetailIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\LegDetailIdentifier $item
     * @return \ArrayType\ArrayOfLegDetailIdentifier
     */
    public function addToLegDetailIdentifier(\StructType\LegDetailIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LegDetailIdentifier) {
            throw new \InvalidArgumentException(sprintf('The LegDetailIdentifier property can only contain items of type \StructType\LegDetailIdentifier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LegDetailIdentifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LegDetailIdentifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LegDetailIdentifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LegDetailIdentifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LegDetailIdentifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LegDetailIdentifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LegDetailIdentifier
     */
    public function getAttributeName()
    {
        return 'LegDetailIdentifier';
    }
}
