<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetFareInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRetFareInfo
 * @subpackage Arrays
 */
class ArrayOfRetFareInfo extends AbstractStructArrayBase
{
    /**
     * The RetFareInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetFareInfo[]
     */
    public $RetFareInfo;
    /**
     * Constructor method for ArrayOfRetFareInfo
     * @uses ArrayOfRetFareInfo::setRetFareInfo()
     * @param \StructType\RetFareInfo[] $retFareInfo
     */
    public function __construct(array $retFareInfo = array())
    {
        $this
            ->setRetFareInfo($retFareInfo);
    }
    /**
     * Get RetFareInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetFareInfo[]|null
     */
    public function getRetFareInfo()
    {
        return isset($this->RetFareInfo) ? $this->RetFareInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetFareInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetFareInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetFareInfoForArrayConstraintsFromSetRetFareInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetFareInfoRetFareInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetFareInfoRetFareInfoItem instanceof \StructType\RetFareInfo) {
                $invalidValues[] = is_object($arrayOfRetFareInfoRetFareInfoItem) ? get_class($arrayOfRetFareInfoRetFareInfoItem) : sprintf('%s(%s)', gettype($arrayOfRetFareInfoRetFareInfoItem), var_export($arrayOfRetFareInfoRetFareInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RetFareInfo property can only contain items of type \StructType\RetFareInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RetFareInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RetFareInfo[] $retFareInfo
     * @return \ArrayType\ArrayOfRetFareInfo
     */
    public function setRetFareInfo(array $retFareInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($retFareInfoArrayErrorMessage = self::validateRetFareInfoForArrayConstraintsFromSetRetFareInfo($retFareInfo))) {
            throw new \InvalidArgumentException($retFareInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($retFareInfo) || (is_array($retFareInfo) && empty($retFareInfo))) {
            unset($this->RetFareInfo);
        } else {
            $this->RetFareInfo = $retFareInfo;
        }
        return $this;
    }
    /**
     * Add item to RetFareInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\RetFareInfo $item
     * @return \ArrayType\ArrayOfRetFareInfo
     */
    public function addToRetFareInfo(\StructType\RetFareInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetFareInfo) {
            throw new \InvalidArgumentException(sprintf('The RetFareInfo property can only contain items of type \StructType\RetFareInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RetFareInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RetFareInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RetFareInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RetFareInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RetFareInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RetFareInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RetFareInfo
     */
    public function getAttributeName()
    {
        return 'RetFareInfo';
    }
}
