<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetFareType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRetFareType
 * @subpackage Arrays
 */
class ArrayOfRetFareType extends AbstractStructArrayBase
{
    /**
     * The RetFareType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetFareType[]
     */
    public $RetFareType;
    /**
     * Constructor method for ArrayOfRetFareType
     * @uses ArrayOfRetFareType::setRetFareType()
     * @param \StructType\RetFareType[] $retFareType
     */
    public function __construct(array $retFareType = array())
    {
        $this
            ->setRetFareType($retFareType);
    }
    /**
     * Get RetFareType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetFareType[]|null
     */
    public function getRetFareType()
    {
        return isset($this->RetFareType) ? $this->RetFareType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetFareType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetFareType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetFareTypeForArrayConstraintsFromSetRetFareType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetFareTypeRetFareTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetFareTypeRetFareTypeItem instanceof \StructType\RetFareType) {
                $invalidValues[] = is_object($arrayOfRetFareTypeRetFareTypeItem) ? get_class($arrayOfRetFareTypeRetFareTypeItem) : sprintf('%s(%s)', gettype($arrayOfRetFareTypeRetFareTypeItem), var_export($arrayOfRetFareTypeRetFareTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RetFareType property can only contain items of type \StructType\RetFareType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RetFareType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RetFareType[] $retFareType
     * @return \ArrayType\ArrayOfRetFareType
     */
    public function setRetFareType(array $retFareType = array())
    {
        // validation for constraint: array
        if ('' !== ($retFareTypeArrayErrorMessage = self::validateRetFareTypeForArrayConstraintsFromSetRetFareType($retFareType))) {
            throw new \InvalidArgumentException($retFareTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($retFareType) || (is_array($retFareType) && empty($retFareType))) {
            unset($this->RetFareType);
        } else {
            $this->RetFareType = $retFareType;
        }
        return $this;
    }
    /**
     * Add item to RetFareType value
     * @throws \InvalidArgumentException
     * @param \StructType\RetFareType $item
     * @return \ArrayType\ArrayOfRetFareType
     */
    public function addToRetFareType(\StructType\RetFareType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetFareType) {
            throw new \InvalidArgumentException(sprintf('The RetFareType property can only contain items of type \StructType\RetFareType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RetFareType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RetFareType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RetFareType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RetFareType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RetFareType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RetFareType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RetFareType
     */
    public function getAttributeName()
    {
        return 'RetFareType';
    }
}
