<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReturnFlightSegmentDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfReturnFlightSegmentDetail
 * @subpackage Arrays
 */
class ArrayOfReturnFlightSegmentDetail extends AbstractStructArrayBase
{
    /**
     * The ReturnFlightSegmentDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReturnFlightSegmentDetail[]
     */
    public $ReturnFlightSegmentDetail;
    /**
     * Constructor method for ArrayOfReturnFlightSegmentDetail
     * @uses ArrayOfReturnFlightSegmentDetail::setReturnFlightSegmentDetail()
     * @param \StructType\ReturnFlightSegmentDetail[] $returnFlightSegmentDetail
     */
    public function __construct(array $returnFlightSegmentDetail = array())
    {
        $this
            ->setReturnFlightSegmentDetail($returnFlightSegmentDetail);
    }
    /**
     * Get ReturnFlightSegmentDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReturnFlightSegmentDetail[]|null
     */
    public function getReturnFlightSegmentDetail()
    {
        return isset($this->ReturnFlightSegmentDetail) ? $this->ReturnFlightSegmentDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReturnFlightSegmentDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReturnFlightSegmentDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReturnFlightSegmentDetailForArrayConstraintsFromSetReturnFlightSegmentDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfReturnFlightSegmentDetailReturnFlightSegmentDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfReturnFlightSegmentDetailReturnFlightSegmentDetailItem instanceof \StructType\ReturnFlightSegmentDetail) {
                $invalidValues[] = is_object($arrayOfReturnFlightSegmentDetailReturnFlightSegmentDetailItem) ? get_class($arrayOfReturnFlightSegmentDetailReturnFlightSegmentDetailItem) : sprintf('%s(%s)', gettype($arrayOfReturnFlightSegmentDetailReturnFlightSegmentDetailItem), var_export($arrayOfReturnFlightSegmentDetailReturnFlightSegmentDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReturnFlightSegmentDetail property can only contain items of type \StructType\ReturnFlightSegmentDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReturnFlightSegmentDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReturnFlightSegmentDetail[] $returnFlightSegmentDetail
     * @return \ArrayType\ArrayOfReturnFlightSegmentDetail
     */
    public function setReturnFlightSegmentDetail(array $returnFlightSegmentDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($returnFlightSegmentDetailArrayErrorMessage = self::validateReturnFlightSegmentDetailForArrayConstraintsFromSetReturnFlightSegmentDetail($returnFlightSegmentDetail))) {
            throw new \InvalidArgumentException($returnFlightSegmentDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($returnFlightSegmentDetail) || (is_array($returnFlightSegmentDetail) && empty($returnFlightSegmentDetail))) {
            unset($this->ReturnFlightSegmentDetail);
        } else {
            $this->ReturnFlightSegmentDetail = $returnFlightSegmentDetail;
        }
        return $this;
    }
    /**
     * Add item to ReturnFlightSegmentDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ReturnFlightSegmentDetail $item
     * @return \ArrayType\ArrayOfReturnFlightSegmentDetail
     */
    public function addToReturnFlightSegmentDetail(\StructType\ReturnFlightSegmentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReturnFlightSegmentDetail) {
            throw new \InvalidArgumentException(sprintf('The ReturnFlightSegmentDetail property can only contain items of type \StructType\ReturnFlightSegmentDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReturnFlightSegmentDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReturnFlightSegmentDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReturnFlightSegmentDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReturnFlightSegmentDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReturnFlightSegmentDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReturnFlightSegmentDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReturnFlightSegmentDetail
     */
    public function getAttributeName()
    {
        return 'ReturnFlightSegmentDetail';
    }
}
