<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSegmentDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSegmentDetail
 * @subpackage Arrays
 */
class ArrayOfSegmentDetail extends AbstractStructArrayBase
{
    /**
     * The SegmentDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SegmentDetail[]
     */
    public $SegmentDetail;
    /**
     * Constructor method for ArrayOfSegmentDetail
     * @uses ArrayOfSegmentDetail::setSegmentDetail()
     * @param \StructType\SegmentDetail[] $segmentDetail
     */
    public function __construct(array $segmentDetail = array())
    {
        $this
            ->setSegmentDetail($segmentDetail);
    }
    /**
     * Get SegmentDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SegmentDetail[]|null
     */
    public function getSegmentDetail()
    {
        return isset($this->SegmentDetail) ? $this->SegmentDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSegmentDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSegmentDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSegmentDetailForArrayConstraintsFromSetSegmentDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSegmentDetailSegmentDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfSegmentDetailSegmentDetailItem instanceof \StructType\SegmentDetail) {
                $invalidValues[] = is_object($arrayOfSegmentDetailSegmentDetailItem) ? get_class($arrayOfSegmentDetailSegmentDetailItem) : sprintf('%s(%s)', gettype($arrayOfSegmentDetailSegmentDetailItem), var_export($arrayOfSegmentDetailSegmentDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SegmentDetail property can only contain items of type \StructType\SegmentDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SegmentDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SegmentDetail[] $segmentDetail
     * @return \ArrayType\ArrayOfSegmentDetail
     */
    public function setSegmentDetail(array $segmentDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($segmentDetailArrayErrorMessage = self::validateSegmentDetailForArrayConstraintsFromSetSegmentDetail($segmentDetail))) {
            throw new \InvalidArgumentException($segmentDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($segmentDetail) || (is_array($segmentDetail) && empty($segmentDetail))) {
            unset($this->SegmentDetail);
        } else {
            $this->SegmentDetail = $segmentDetail;
        }
        return $this;
    }
    /**
     * Add item to SegmentDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\SegmentDetail $item
     * @return \ArrayType\ArrayOfSegmentDetail
     */
    public function addToSegmentDetail(\StructType\SegmentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SegmentDetail) {
            throw new \InvalidArgumentException(sprintf('The SegmentDetail property can only contain items of type \StructType\SegmentDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SegmentDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SegmentDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SegmentDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SegmentDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SegmentDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SegmentDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SegmentDetail
     */
    public function getAttributeName()
    {
        return 'SegmentDetail';
    }
}
