<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServiceQuote ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfServiceQuote
 * @subpackage Arrays
 */
class ArrayOfServiceQuote extends AbstractStructArrayBase
{
    /**
     * The ServiceQuote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ServiceQuote[]
     */
    public $ServiceQuote;
    /**
     * Constructor method for ArrayOfServiceQuote
     * @uses ArrayOfServiceQuote::setServiceQuote()
     * @param \StructType\ServiceQuote[] $serviceQuote
     */
    public function __construct(array $serviceQuote = array())
    {
        $this
            ->setServiceQuote($serviceQuote);
    }
    /**
     * Get ServiceQuote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ServiceQuote[]|null
     */
    public function getServiceQuote()
    {
        return isset($this->ServiceQuote) ? $this->ServiceQuote : null;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceQuote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceQuote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceQuoteForArrayConstraintsFromSetServiceQuote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfServiceQuoteServiceQuoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfServiceQuoteServiceQuoteItem instanceof \StructType\ServiceQuote) {
                $invalidValues[] = is_object($arrayOfServiceQuoteServiceQuoteItem) ? get_class($arrayOfServiceQuoteServiceQuoteItem) : sprintf('%s(%s)', gettype($arrayOfServiceQuoteServiceQuoteItem), var_export($arrayOfServiceQuoteServiceQuoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceQuote property can only contain items of type \StructType\ServiceQuote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceQuote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceQuote[] $serviceQuote
     * @return \ArrayType\ArrayOfServiceQuote
     */
    public function setServiceQuote(array $serviceQuote = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceQuoteArrayErrorMessage = self::validateServiceQuoteForArrayConstraintsFromSetServiceQuote($serviceQuote))) {
            throw new \InvalidArgumentException($serviceQuoteArrayErrorMessage, __LINE__);
        }
        if (is_null($serviceQuote) || (is_array($serviceQuote) && empty($serviceQuote))) {
            unset($this->ServiceQuote);
        } else {
            $this->ServiceQuote = $serviceQuote;
        }
        return $this;
    }
    /**
     * Add item to ServiceQuote value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceQuote $item
     * @return \ArrayType\ArrayOfServiceQuote
     */
    public function addToServiceQuote(\StructType\ServiceQuote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceQuote) {
            throw new \InvalidArgumentException(sprintf('The ServiceQuote property can only contain items of type \StructType\ServiceQuote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceQuote[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ServiceQuote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ServiceQuote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ServiceQuote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ServiceQuote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ServiceQuote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceQuote
     */
    public function getAttributeName()
    {
        return 'ServiceQuote';
    }
}
