<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewAARQuote ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewAARQuote
 * @subpackage Arrays
 */
class ArrayOfViewAARQuote extends AbstractStructArrayBase
{
    /**
     * The ViewAARQuote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewAARQuote[]
     */
    public $ViewAARQuote;
    /**
     * Constructor method for ArrayOfViewAARQuote
     * @uses ArrayOfViewAARQuote::setViewAARQuote()
     * @param \StructType\ViewAARQuote[] $viewAARQuote
     */
    public function __construct(array $viewAARQuote = array())
    {
        $this
            ->setViewAARQuote($viewAARQuote);
    }
    /**
     * Get ViewAARQuote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewAARQuote[]|null
     */
    public function getViewAARQuote()
    {
        return isset($this->ViewAARQuote) ? $this->ViewAARQuote : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewAARQuote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewAARQuote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewAARQuoteForArrayConstraintsFromSetViewAARQuote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewAARQuoteViewAARQuoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewAARQuoteViewAARQuoteItem instanceof \StructType\ViewAARQuote) {
                $invalidValues[] = is_object($arrayOfViewAARQuoteViewAARQuoteItem) ? get_class($arrayOfViewAARQuoteViewAARQuoteItem) : sprintf('%s(%s)', gettype($arrayOfViewAARQuoteViewAARQuoteItem), var_export($arrayOfViewAARQuoteViewAARQuoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewAARQuote property can only contain items of type \StructType\ViewAARQuote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewAARQuote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewAARQuote[] $viewAARQuote
     * @return \ArrayType\ArrayOfViewAARQuote
     */
    public function setViewAARQuote(array $viewAARQuote = array())
    {
        // validation for constraint: array
        if ('' !== ($viewAARQuoteArrayErrorMessage = self::validateViewAARQuoteForArrayConstraintsFromSetViewAARQuote($viewAARQuote))) {
            throw new \InvalidArgumentException($viewAARQuoteArrayErrorMessage, __LINE__);
        }
        if (is_null($viewAARQuote) || (is_array($viewAARQuote) && empty($viewAARQuote))) {
            unset($this->ViewAARQuote);
        } else {
            $this->ViewAARQuote = $viewAARQuote;
        }
        return $this;
    }
    /**
     * Add item to ViewAARQuote value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewAARQuote $item
     * @return \ArrayType\ArrayOfViewAARQuote
     */
    public function addToViewAARQuote(\StructType\ViewAARQuote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewAARQuote) {
            throw new \InvalidArgumentException(sprintf('The ViewAARQuote property can only contain items of type \StructType\ViewAARQuote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewAARQuote[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewAARQuote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewAARQuote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewAARQuote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewAARQuote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewAARQuote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewAARQuote
     */
    public function getAttributeName()
    {
        return 'ViewAARQuote';
    }
}
