<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewFareQuote ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewFareQuote
 * @subpackage Arrays
 */
class ArrayOfViewFareQuote extends AbstractStructArrayBase
{
    /**
     * The ViewFareQuote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewFareQuote[]
     */
    public $ViewFareQuote;
    /**
     * Constructor method for ArrayOfViewFareQuote
     * @uses ArrayOfViewFareQuote::setViewFareQuote()
     * @param \StructType\ViewFareQuote[] $viewFareQuote
     */
    public function __construct(array $viewFareQuote = array())
    {
        $this
            ->setViewFareQuote($viewFareQuote);
    }
    /**
     * Get ViewFareQuote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewFareQuote[]|null
     */
    public function getViewFareQuote()
    {
        return isset($this->ViewFareQuote) ? $this->ViewFareQuote : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewFareQuote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewFareQuote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewFareQuoteForArrayConstraintsFromSetViewFareQuote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewFareQuoteViewFareQuoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewFareQuoteViewFareQuoteItem instanceof \StructType\ViewFareQuote) {
                $invalidValues[] = is_object($arrayOfViewFareQuoteViewFareQuoteItem) ? get_class($arrayOfViewFareQuoteViewFareQuoteItem) : sprintf('%s(%s)', gettype($arrayOfViewFareQuoteViewFareQuoteItem), var_export($arrayOfViewFareQuoteViewFareQuoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewFareQuote property can only contain items of type \StructType\ViewFareQuote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewFareQuote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewFareQuote[] $viewFareQuote
     * @return \ArrayType\ArrayOfViewFareQuote
     */
    public function setViewFareQuote(array $viewFareQuote = array())
    {
        // validation for constraint: array
        if ('' !== ($viewFareQuoteArrayErrorMessage = self::validateViewFareQuoteForArrayConstraintsFromSetViewFareQuote($viewFareQuote))) {
            throw new \InvalidArgumentException($viewFareQuoteArrayErrorMessage, __LINE__);
        }
        if (is_null($viewFareQuote) || (is_array($viewFareQuote) && empty($viewFareQuote))) {
            unset($this->ViewFareQuote);
        } else {
            $this->ViewFareQuote = $viewFareQuote;
        }
        return $this;
    }
    /**
     * Add item to ViewFareQuote value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewFareQuote $item
     * @return \ArrayType\ArrayOfViewFareQuote
     */
    public function addToViewFareQuote(\StructType\ViewFareQuote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewFareQuote) {
            throw new \InvalidArgumentException(sprintf('The ViewFareQuote property can only contain items of type \StructType\ViewFareQuote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewFareQuote[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewFareQuote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewFareQuote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewFareQuote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewFareQuote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewFareQuote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewFareQuote
     */
    public function getAttributeName()
    {
        return 'ViewFareQuote';
    }
}
