<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewServiceQuote ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewServiceQuote
 * @subpackage Arrays
 */
class ArrayOfViewServiceQuote extends AbstractStructArrayBase
{
    /**
     * The ViewServiceQuote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewServiceQuote[]
     */
    public $ViewServiceQuote;
    /**
     * Constructor method for ArrayOfViewServiceQuote
     * @uses ArrayOfViewServiceQuote::setViewServiceQuote()
     * @param \StructType\ViewServiceQuote[] $viewServiceQuote
     */
    public function __construct(array $viewServiceQuote = array())
    {
        $this
            ->setViewServiceQuote($viewServiceQuote);
    }
    /**
     * Get ViewServiceQuote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewServiceQuote[]|null
     */
    public function getViewServiceQuote()
    {
        return isset($this->ViewServiceQuote) ? $this->ViewServiceQuote : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewServiceQuote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewServiceQuote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewServiceQuoteForArrayConstraintsFromSetViewServiceQuote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewServiceQuoteViewServiceQuoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewServiceQuoteViewServiceQuoteItem instanceof \StructType\ViewServiceQuote) {
                $invalidValues[] = is_object($arrayOfViewServiceQuoteViewServiceQuoteItem) ? get_class($arrayOfViewServiceQuoteViewServiceQuoteItem) : sprintf('%s(%s)', gettype($arrayOfViewServiceQuoteViewServiceQuoteItem), var_export($arrayOfViewServiceQuoteViewServiceQuoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewServiceQuote property can only contain items of type \StructType\ViewServiceQuote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewServiceQuote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewServiceQuote[] $viewServiceQuote
     * @return \ArrayType\ArrayOfViewServiceQuote
     */
    public function setViewServiceQuote(array $viewServiceQuote = array())
    {
        // validation for constraint: array
        if ('' !== ($viewServiceQuoteArrayErrorMessage = self::validateViewServiceQuoteForArrayConstraintsFromSetViewServiceQuote($viewServiceQuote))) {
            throw new \InvalidArgumentException($viewServiceQuoteArrayErrorMessage, __LINE__);
        }
        if (is_null($viewServiceQuote) || (is_array($viewServiceQuote) && empty($viewServiceQuote))) {
            unset($this->ViewServiceQuote);
        } else {
            $this->ViewServiceQuote = $viewServiceQuote;
        }
        return $this;
    }
    /**
     * Add item to ViewServiceQuote value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewServiceQuote $item
     * @return \ArrayType\ArrayOfViewServiceQuote
     */
    public function addToViewServiceQuote(\StructType\ViewServiceQuote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewServiceQuote) {
            throw new \InvalidArgumentException(sprintf('The ViewServiceQuote property can only contain items of type \StructType\ViewServiceQuote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewServiceQuote[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewServiceQuote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewServiceQuote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewServiceQuote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewServiceQuote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewServiceQuote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewServiceQuote
     */
    public function getAttributeName()
    {
        return 'ViewServiceQuote';
    }
}
