<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RetrieveFastFareSearch' => '\\StructType\\RetrieveFastFareSearch',
            'RetrieveFastFareSearchResponse' => '\\StructType\\RetrieveFastFareSearchResponse',
            'RetrieveFareQuote' => '\\StructType\\RetrieveFareQuote',
            'RetrieveFareQuoteResponse' => '\\StructType\\RetrieveFareQuoteResponse',
            'RetrieveFareQuoteDateRange' => '\\StructType\\RetrieveFareQuoteDateRange',
            'RetrieveFareQuoteDateRangeResponse' => '\\StructType\\RetrieveFareQuoteDateRangeResponse',
            'RetrieveServiceQuote' => '\\StructType\\RetrieveServiceQuote',
            'RetrieveServiceQuoteResponse' => '\\StructType\\RetrieveServiceQuoteResponse',
            'RetrieveServiceQuotes' => '\\StructType\\RetrieveServiceQuotes',
            'RetrieveServiceQuotesResponse' => '\\StructType\\RetrieveServiceQuotesResponse',
            'RetrieveSystemFareQuote' => '\\StructType\\RetrieveSystemFareQuote',
            'RetrieveSystemFareQuoteResponse' => '\\StructType\\RetrieveSystemFareQuoteResponse',
            'RetrieveFareQuoteShop' => '\\StructType\\RetrieveFareQuoteShop',
            'RetrieveFareQuoteShopResponse' => '\\StructType\\RetrieveFareQuoteShopResponse',
            'RetrieveFareQuoteShopDateRange' => '\\StructType\\RetrieveFareQuoteShopDateRange',
            'RetrieveFareQuoteShopDateRangeResponse' => '\\StructType\\RetrieveFareQuoteShopDateRangeResponse',
            'AdjustFares' => '\\StructType\\AdjustFares',
            'AdjustFaresResponse' => '\\StructType\\AdjustFaresResponse',
            'AdjustFaresShop' => '\\StructType\\AdjustFaresShop',
            'AdjustFaresShopResponse' => '\\StructType\\AdjustFaresShopResponse',
            'AdjustFaresSession' => '\\StructType\\AdjustFaresSession',
            'AdjustFaresSessionResponse' => '\\StructType\\AdjustFaresSessionResponse',
            'AdjustSpecialServices' => '\\StructType\\AdjustSpecialServices',
            'AdjustSpecialServicesResponse' => '\\StructType\\AdjustSpecialServicesResponse',
            'RetrieveServiceSummaries' => '\\StructType\\RetrieveServiceSummaries',
            'RetrieveServiceSummariesResponse' => '\\StructType\\RetrieveServiceSummariesResponse',
            'RetrieveServiceQuoteShop' => '\\StructType\\RetrieveServiceQuoteShop',
            'RetrieveServiceQuoteShopResponse' => '\\StructType\\RetrieveServiceQuoteShopResponse',
            'RetrieveAARQuote' => '\\StructType\\RetrieveAARQuote',
            'RetrieveAARQuoteResponse' => '\\StructType\\RetrieveAARQuoteResponse',
            'RetrieveFareBundleDetails' => '\\StructType\\RetrieveFareBundleDetails',
            'RetrieveFareBundleDetailsResponse' => '\\StructType\\RetrieveFareBundleDetailsResponse',
            'RetrieveServiceBundleDetails' => '\\StructType\\RetrieveServiceBundleDetails',
            'RetrieveServiceBundleDetailsResponse' => '\\StructType\\RetrieveServiceBundleDetailsResponse',
            'FastFareSearchInfo' => '\\StructType\\FastFareSearchInfo',
            'ArrayOfFastFareSearchTripDetail' => '\\ArrayType\\ArrayOfFastFareSearchTripDetail',
            'FastFareSearchTripDetail' => '\\StructType\\FastFareSearchTripDetail',
            'ArrayOfFastFareSearchTravelerInfo' => '\\ArrayType\\ArrayOfFastFareSearchTravelerInfo',
            'FastFareSearchTravelerInfo' => '\\StructType\\FastFareSearchTravelerInfo',
            'CarrierInfo' => '\\StructType\\CarrierInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'TransactionInfoNoSession' => '\\StructType\\TransactionInfoNoSession',
            'BaseFareChargeInfo' => '\\StructType\\BaseFareChargeInfo',
            'FareAdjustment' => '\\StructType\\FareAdjustment',
            'ArrayOfFareAdjustmentDetail' => '\\ArrayType\\ArrayOfFareAdjustmentDetail',
            'FareAdjustmentDetail' => '\\StructType\\FareAdjustmentDetail',
            'FareAdjustmentBase' => '\\StructType\\FareAdjustmentBase',
            'FareShopAdjustment' => '\\StructType\\FareShopAdjustment',
            'ArrayOfFareShopAdjustmentDetail' => '\\ArrayType\\ArrayOfFareShopAdjustmentDetail',
            'FareShopAdjustmentDetail' => '\\StructType\\FareShopAdjustmentDetail',
            'SpecialServiceAdjustment' => '\\StructType\\SpecialServiceAdjustment',
            'ArrayOfSpecialServiceAdjustmentDetail' => '\\ArrayType\\ArrayOfSpecialServiceAdjustmentDetail',
            'SpecialServiceAdjustmentDetail' => '\\StructType\\SpecialServiceAdjustmentDetail',
            'AdjustmentDetailBase' => '\\StructType\\AdjustmentDetailBase',
            'RetrieveServiceSummaryRequest' => '\\StructType\\RetrieveServiceSummaryRequest',
            'RetriveServiceBundleDetailsRequest' => '\\StructType\\RetriveServiceBundleDetailsRequest',
            'ViewFastFareSearch' => '\\StructType\\ViewFastFareSearch',
            'ArrayOfFareDetail' => '\\ArrayType\\ArrayOfFareDetail',
            'FareDetail' => '\\StructType\\FareDetail',
            'ArrayOfFlightDetail' => '\\ArrayType\\ArrayOfFlightDetail',
            'FlightDetail' => '\\StructType\\FlightDetail',
            'ArrayOfLegDetailIdentifier' => '\\ArrayType\\ArrayOfLegDetailIdentifier',
            'LegDetailIdentifier' => '\\StructType\\LegDetailIdentifier',
            'ArrayOfFlightLegDetailed' => '\\ArrayType\\ArrayOfFlightLegDetailed',
            'FlightLegDetailed' => '\\StructType\\FlightLegDetailed',
            'ArrayOfTripInfo' => '\\ArrayType\\ArrayOfTripInfo',
            'TripInfo' => '\\StructType\\TripInfo',
            'ArrayOfFareTypeInfo' => '\\ArrayType\\ArrayOfFareTypeInfo',
            'FareTypeInfo' => '\\StructType\\FareTypeInfo',
            'ArrayOfApplicableFareInfo' => '\\ArrayType\\ArrayOfApplicableFareInfo',
            'ApplicableFareInfo' => '\\StructType\\ApplicableFareInfo',
            'ArrayOfCombinedTripInfo' => '\\ArrayType\\ArrayOfCombinedTripInfo',
            'CombinedTripInfo' => '\\StructType\\CombinedTripInfo',
            'ViewFareQuote' => '\\StructType\\ViewFareQuote',
            'ArrayOfFlightSegment' => '\\ArrayType\\ArrayOfFlightSegment',
            'FlightSegment' => '\\StructType\\FlightSegment',
            'ArrayOfFareType' => '\\ArrayType\\ArrayOfFareType',
            'FareType' => '\\StructType\\FareType',
            'ArrayOfFareInfo' => '\\ArrayType\\ArrayOfFareInfo',
            'FareInfo' => '\\StructType\\FareInfo',
            'BaseFareInfo' => '\\StructType\\BaseFareInfo',
            'ArrayOfApplicableTaxDetail' => '\\ArrayType\\ArrayOfApplicableTaxDetail',
            'ApplicableTaxDetail' => '\\StructType\\ApplicableTaxDetail',
            'ArrayOfCombinableTrip' => '\\ArrayType\\ArrayOfCombinableTrip',
            'CombinableTrip' => '\\StructType\\CombinableTrip',
            'ArrayOfCombinableFlight' => '\\ArrayType\\ArrayOfCombinableFlight',
            'CombinableFlight' => '\\StructType\\CombinableFlight',
            'ArrayOfCombinableFareInfo' => '\\ArrayType\\ArrayOfCombinableFareInfo',
            'CombinableFareInfo' => '\\StructType\\CombinableFareInfo',
            'ArrayOfReturnFlightSegmentDetail' => '\\ArrayType\\ArrayOfReturnFlightSegmentDetail',
            'ReturnFlightSegmentDetail' => '\\StructType\\ReturnFlightSegmentDetail',
            'ArrayOfRetFareType' => '\\ArrayType\\ArrayOfRetFareType',
            'RetFareType' => '\\StructType\\RetFareType',
            'ArrayOfRetFareInfo' => '\\ArrayType\\ArrayOfRetFareInfo',
            'RetFareInfo' => '\\StructType\\RetFareInfo',
            'ArrayOfFlightLegDetail' => '\\ArrayType\\ArrayOfFlightLegDetail',
            'FlightLegDetail' => '\\StructType\\FlightLegDetail',
            'ArrayOfLegDetail' => '\\ArrayType\\ArrayOfLegDetail',
            'LegDetail' => '\\StructType\\LegDetail',
            'ArrayOfSegmentDetail' => '\\ArrayType\\ArrayOfSegmentDetail',
            'SegmentDetail' => '\\StructType\\SegmentDetail',
            'ArrayOfTaxDetail' => '\\ArrayType\\ArrayOfTaxDetail',
            'TaxDetail' => '\\StructType\\TaxDetail',
            'ViewServiceQuotes' => '\\StructType\\ViewServiceQuotes',
            'ArrayOfViewServiceQuote' => '\\ArrayType\\ArrayOfViewServiceQuote',
            'ViewServiceQuote' => '\\StructType\\ViewServiceQuote',
            'ArrayOfApplicableTax' => '\\ArrayType\\ArrayOfApplicableTax',
            'ApplicableTax' => '\\StructType\\ApplicableTax',
            'ViewSystemFareQuote' => '\\StructType\\ViewSystemFareQuote',
            'ArrayOfViewFareQuote' => '\\ArrayType\\ArrayOfViewFareQuote',
            'ServiceSummaryResponse' => '\\StructType\\ServiceSummaryResponse',
            'ArrayOfServiceSummary' => '\\ArrayType\\ArrayOfServiceSummary',
            'ServiceSummary' => '\\StructType\\ServiceSummary',
            'ViewAARQuotes' => '\\StructType\\ViewAARQuotes',
            'ArrayOfViewAARQuote' => '\\ArrayType\\ArrayOfViewAARQuote',
            'ViewAARQuote' => '\\StructType\\ViewAARQuote',
            'ViewFareBundleDetailsResponse' => '\\StructType\\ViewFareBundleDetailsResponse',
            'ArrayOfBundleServiceDetail' => '\\ArrayType\\ArrayOfBundleServiceDetail',
            'BundleServiceDetail' => '\\StructType\\BundleServiceDetail',
            'ViewServiceBundleDetailsResponse' => '\\StructType\\ViewServiceBundleDetailsResponse',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'ArrayOfFareQuoteDetail' => '\\ArrayType\\ArrayOfFareQuoteDetail',
            'FareQuoteDetail' => '\\StructType\\FareQuoteDetail',
            'ArrayOfFareQuoteRequestInfo' => '\\ArrayType\\ArrayOfFareQuoteRequestInfo',
            'FareQuoteRequestInfo' => '\\StructType\\FareQuoteRequestInfo',
            'RetrieveFareQuoteByDateRange' => '\\StructType\\RetrieveFareQuoteByDateRange',
            'ArrayOfFareQuoteDetailDateRange' => '\\ArrayType\\ArrayOfFareQuoteDetailDateRange',
            'FareQuoteDetailDateRange' => '\\StructType\\FareQuoteDetailDateRange',
            'RetrieveFareQuoteShopByDateRange' => '\\StructType\\RetrieveFareQuoteShopByDateRange',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfServiceQuote' => '\\ArrayType\\ArrayOfServiceQuote',
            'ServiceQuote' => '\\StructType\\ServiceQuote',
            'RetrieveServiceQuotesShop' => '\\StructType\\RetrieveServiceQuotesShop',
            'ArrayOfAARQuote' => '\\ArrayType\\ArrayOfAARQuote',
            'AARQuote' => '\\StructType\\AARQuote',
            'ArrayOfAARRequestPtc' => '\\ArrayType\\ArrayOfAARRequestPtc',
            'AARRequestPtc' => '\\StructType\\AARRequestPtc',
            'IataNumberInfo' => '\\StructType\\IataNumberInfo',
            'RetrieveFareBundleDetailsRequest' => '\\StructType\\RetrieveFareBundleDetailsRequest',
        );
    }
}
