<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IataNumberInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:IataNumberInfo
 * @subpackage Structs
 */
class IataNumberInfo extends BaseFareChargeInfo
{
    /**
     * The IataNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IataNumber;
    /**
     * Constructor method for IataNumberInfo
     * @uses IataNumberInfo::setIataNumber()
     * @param string $iataNumber
     */
    public function __construct($iataNumber = null)
    {
        $this
            ->setIataNumber($iataNumber);
    }
    /**
     * Get IataNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIataNumber()
    {
        return isset($this->IataNumber) ? $this->IataNumber : null;
    }
    /**
     * Set IataNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $iataNumber
     * @return \StructType\IataNumberInfo
     */
    public function setIataNumber($iataNumber = null)
    {
        // validation for constraint: string
        if (!is_null($iataNumber) && !is_string($iataNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iataNumber, true), gettype($iataNumber)), __LINE__);
        }
        if (is_null($iataNumber) || (is_array($iataNumber) && empty($iataNumber))) {
            unset($this->IataNumber);
        } else {
            $this->IataNumber = $iataNumber;
        }
        return $this;
    }
}
