<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ViewFastFareSearch StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ViewFastFareSearch
 * @subpackage Structs
 */
class ViewFastFareSearch extends AbstractStructBase
{
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * The FareDetails
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFareDetail
     */
    public $FareDetails;
    /**
     * The FlightDetails
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFlightDetail
     */
    public $FlightDetails;
    /**
     * The FlightLegDetails
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFlightLegDetailed
     */
    public $FlightLegDetails;
    /**
     * The TripInfos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfTripInfo
     */
    public $TripInfos;
    /**
     * Constructor method for ViewFastFareSearch
     * @uses ViewFastFareSearch::setExceptions()
     * @uses ViewFastFareSearch::setFareDetails()
     * @uses ViewFastFareSearch::setFlightDetails()
     * @uses ViewFastFareSearch::setFlightLegDetails()
     * @uses ViewFastFareSearch::setTripInfos()
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @param \ArrayType\ArrayOfFareDetail $fareDetails
     * @param \ArrayType\ArrayOfFlightDetail $flightDetails
     * @param \ArrayType\ArrayOfFlightLegDetailed $flightLegDetails
     * @param \ArrayType\ArrayOfTripInfo $tripInfos
     */
    public function __construct(\StructType\ExceptionInformation_Exceptions $exceptions = null, \ArrayType\ArrayOfFareDetail $fareDetails = null, \ArrayType\ArrayOfFlightDetail $flightDetails = null, \ArrayType\ArrayOfFlightLegDetailed $flightLegDetails = null, \ArrayType\ArrayOfTripInfo $tripInfos = null)
    {
        $this
            ->setExceptions($exceptions)
            ->setFareDetails($fareDetails)
            ->setFlightDetails($flightDetails)
            ->setFlightLegDetails($flightLegDetails)
            ->setTripInfos($tripInfos);
    }
    /**
     * Get Exceptions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return isset($this->Exceptions) ? $this->Exceptions : null;
    }
    /**
     * Set Exceptions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\ViewFastFareSearch
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        if (is_null($exceptions) || (is_array($exceptions) && empty($exceptions))) {
            unset($this->Exceptions);
        } else {
            $this->Exceptions = $exceptions;
        }
        return $this;
    }
    /**
     * Get FareDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFareDetail|null
     */
    public function getFareDetails()
    {
        return isset($this->FareDetails) ? $this->FareDetails : null;
    }
    /**
     * Set FareDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFareDetail $fareDetails
     * @return \StructType\ViewFastFareSearch
     */
    public function setFareDetails(\ArrayType\ArrayOfFareDetail $fareDetails = null)
    {
        if (is_null($fareDetails) || (is_array($fareDetails) && empty($fareDetails))) {
            unset($this->FareDetails);
        } else {
            $this->FareDetails = $fareDetails;
        }
        return $this;
    }
    /**
     * Get FlightDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFlightDetail|null
     */
    public function getFlightDetails()
    {
        return isset($this->FlightDetails) ? $this->FlightDetails : null;
    }
    /**
     * Set FlightDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFlightDetail $flightDetails
     * @return \StructType\ViewFastFareSearch
     */
    public function setFlightDetails(\ArrayType\ArrayOfFlightDetail $flightDetails = null)
    {
        if (is_null($flightDetails) || (is_array($flightDetails) && empty($flightDetails))) {
            unset($this->FlightDetails);
        } else {
            $this->FlightDetails = $flightDetails;
        }
        return $this;
    }
    /**
     * Get FlightLegDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFlightLegDetailed|null
     */
    public function getFlightLegDetails()
    {
        return isset($this->FlightLegDetails) ? $this->FlightLegDetails : null;
    }
    /**
     * Set FlightLegDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFlightLegDetailed $flightLegDetails
     * @return \StructType\ViewFastFareSearch
     */
    public function setFlightLegDetails(\ArrayType\ArrayOfFlightLegDetailed $flightLegDetails = null)
    {
        if (is_null($flightLegDetails) || (is_array($flightLegDetails) && empty($flightLegDetails))) {
            unset($this->FlightLegDetails);
        } else {
            $this->FlightLegDetails = $flightLegDetails;
        }
        return $this;
    }
    /**
     * Get TripInfos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfTripInfo|null
     */
    public function getTripInfos()
    {
        return isset($this->TripInfos) ? $this->TripInfos : null;
    }
    /**
     * Set TripInfos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfTripInfo $tripInfos
     * @return \StructType\ViewFastFareSearch
     */
    public function setTripInfos(\ArrayType\ArrayOfTripInfo $tripInfos = null)
    {
        if (is_null($tripInfos) || (is_array($tripInfos) && empty($tripInfos))) {
            unset($this->TripInfos);
        } else {
            $this->TripInfos = $tripInfos;
        }
        return $this;
    }
}
